
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>emulsion.agent.core.abstract_agent &#8212; EMULSION (Epidemiological Multi-Level Simulation framework)</title>
    <link rel="stylesheet" href="../../../../_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="../../../../_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="../../../../_static/css/custom.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../../../" src="../../../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../../../_static/language_data.js"></script>
    <script async="async" type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.5/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
    <link rel="shortcut icon" href="../../../../_static/STEMAH-favicon.png"/>
    <link rel="index" title="Index" href="../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../search.html" />
   
  <link rel="stylesheet" href="../../../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for emulsion.agent.core.abstract_agent</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">.. module:: emulsion.agent.core.asbtract_agent</span>

<span class="sd">.. moduleauthor:: Sébastien Picault &lt;sebastien.picault@inra.fr&gt;</span>

<span class="sd">Part of this code was adapted from the PADAWAN framework (S. Picault,</span>
<span class="sd">Univ. Lille).</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="c1"># [HEADER]</span>

<span class="kn">from</span>   <span class="nn">functools</span>                  <span class="k">import</span> <span class="n">total_ordering</span>

<span class="kn">import</span> <span class="nn">numpy</span>                      <span class="k">as</span> <span class="nn">np</span>


<span class="kn">from</span>   <span class="nn">emulsion.tools.state</span>       <span class="k">import</span> <span class="n">StateVarDict</span>
<span class="kn">from</span>   <span class="nn">emulsion.agent.meta</span>        <span class="k">import</span> <span class="n">MetaAgent</span>
<span class="kn">from</span>   <span class="nn">emulsion.agent.exceptions</span>  <span class="k">import</span> <span class="n">StateVarNotFoundException</span>
<span class="kn">from</span>   <span class="nn">emulsion.tools.misc</span>        <span class="k">import</span> <span class="n">retrieve_value</span>


<span class="c1">#           _         _                  _                            _</span>
<span class="c1">#     /\   | |       | |                | |     /\                   | |</span>
<span class="c1">#    /  \  | |__  ___| |_ _ __ __ _  ___| |_   /  \   __ _  ___ _ __ | |_</span>
<span class="c1">#   / /\ \ | &#39;_ \/ __| __| &#39;__/ _` |/ __| __| / /\ \ / _` |/ _ \ &#39;_ \| __|</span>
<span class="c1">#  / ____ \| |_) \__ \ |_| | | (_| | (__| |_ / ____ \ (_| |  __/ | | | |_</span>
<span class="c1"># /_/    \_\_.__/|___/\__|_|  \__,_|\___|\__/_/    \_\__, |\___|_| |_|\__|</span>
<span class="c1">#                                                     __/ |</span>
<span class="c1">#                                                    |___/</span>

<span class="c1">################################################################</span>
<span class="c1"># superclass of all agents</span>

<div class="viewcode-block" id="AbstractAgent"><a class="viewcode-back" href="../../../../emulsion_for_modellers.html#emulsion.agent.core.abstract_agent.AbstractAgent">[docs]</a><span class="nd">@total_ordering</span>
<span class="k">class</span> <span class="nc">AbstractAgent</span><span class="p">(</span><span class="nb">object</span><span class="p">,</span> <span class="n">metaclass</span><span class="o">=</span><span class="n">MetaAgent</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;The Superclass for any multi-level agent. Due to the MetaAgent</span>
<span class="sd">    metaclass, all agents of the same class can be accessed through</span>
<span class="sd">    their ID, using the agdict class attribute. Agents are endowed</span>
<span class="sd">    with an automatic ID and possibly with a label. Agents also belong</span>
<span class="sd">    to families which can be chosen arbitrarily. By default, each</span>
<span class="sd">    agent belongs to the family named afer its own class.</span>

<span class="sd">    An agent is situated in one or more environments. Besides, agents</span>
<span class="sd">    can encapsulate environments where other agents can be</span>
<span class="sd">    situated. Agents are also endowed with State Variables, which can</span>
<span class="sd">    represent either properties of their own, or properties perceived</span>
<span class="sd">    from their inner environment or from the environments where they</span>
<span class="sd">    are situated.</span>

<span class="sd">    &quot;&quot;&quot;</span>
<div class="viewcode-block" id="AbstractAgent.from_dict"><a class="viewcode-back" href="../../../../emulsion_for_modellers.html#emulsion.agent.core.abstract_agent.AbstractAgent.from_dict">[docs]</a>    <span class="nd">@classmethod</span>
    <span class="k">def</span> <span class="nf">from_dict</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="n">dct</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Instantiate an agent using the specified dictionary.</span>

<span class="sd">        TAG: USER</span>
<span class="sd">        &quot;&quot;&quot;</span>
<span class="c1">#        print(&#39;Instantiation of&#39;, cls.__name__, &#39;from dict:&#39;, dct)</span>
        <span class="k">return</span> <span class="bp">cls</span><span class="p">(</span><span class="o">**</span><span class="n">dct</span><span class="p">)</span></div>

    <span class="k">def</span> <span class="nf">_register_instance</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">key</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Register the instance in the instance dictionary of the</span>
<span class="sd">        class. If no key is specified, the agent ID is used.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="n">key</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">_agkey</span> <span class="o">=</span> <span class="n">key</span>
        <span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="n">agdict</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">_agkey</span><span class="p">]</span> <span class="o">=</span> <span class="bp">self</span>


<div class="viewcode-block" id="AbstractAgent.__init__"><a class="viewcode-back" href="../../../../emulsion_for_modellers.html#emulsion.agent.core.abstract_agent.AbstractAgent.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">envt</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">content</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="o">**</span><span class="n">others</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Instantiate an agent. The instance is automatically added</span>
<span class="sd">        to the agentset of its own class. An arbitrary label can be</span>
<span class="sd">        specified to give the agent a label (otherwise a label is</span>
<span class="sd">        automatically computed using the class name and the agent</span>
<span class="sd">        ID).</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="n">agcount</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="n">agcount</span> <span class="o">+</span> <span class="mi">1</span>
        <span class="c1"># agent id</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">agid</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="n">agcount</span>
        <span class="c1"># key used to register agents (agent ID by default)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_agkey</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">agid</span>
        <span class="c1"># environments in which the agent is situated</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_envt</span> <span class="o">=</span> <span class="n">envt</span>
        <span class="c1"># environment encapsulated by the agent</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_content</span> <span class="o">=</span> <span class="n">content</span>
        <span class="c1"># last prototype applied to the agent</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_last_prototype</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="c1"># simulation where the agent belongs</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">simulation</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="c1"># model used to define simulation behaviors</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">model</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="c1"># &quot;true&quot; state variables of the agent</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span> <span class="o">=</span> <span class="n">StateVarDict</span><span class="p">({</span>
            <span class="n">key</span><span class="p">:</span> <span class="p">(</span><span class="n">value</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="k">if</span> <span class="n">callable</span><span class="p">(</span><span class="n">value</span><span class="p">)</span> <span class="k">else</span> <span class="n">value</span><span class="p">)</span>
            <span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">value</span> <span class="ow">in</span> <span class="n">others</span><span class="o">.</span><span class="n">items</span><span class="p">()</span>
        <span class="p">})</span>
        <span class="c1"># refresh cache of class members</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_reset_mbr_cache</span><span class="p">()</span></div>

    <span class="k">def</span> <span class="nf">_reset_mbr_cache</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="c1"># Build a cache of regular class members. This cache is used</span>
        <span class="c1"># to make the &#39;get_information&#39; method as efficient as</span>
        <span class="c1"># possible, thus this operations should be performed at the</span>
        <span class="c1"># end of instance creation (after other attributes have been</span>
        <span class="c1"># initialized)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_mbr_cache</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="n">name</span> <span class="k">for</span> <span class="n">name</span> <span class="ow">in</span> <span class="nb">dir</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span>
                              <span class="k">if</span> <span class="ow">not</span> <span class="n">name</span><span class="o">.</span><span class="n">startswith</span><span class="p">(</span><span class="s1">&#39;_&#39;</span><span class="p">))</span>

    <span class="k">def</span> <span class="nf">__hash__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return a hashcode for the agent. The hashcode is actually</span>
<span class="sd">        the hashcode of the internal id of the object.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="nb">hash</span><span class="p">(</span><span class="nb">id</span><span class="p">(</span><span class="bp">self</span><span class="p">))</span>

    <span class="k">def</span> <span class="nf">__len__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return the &#39;size&#39; of the agent. The size of the agent is based on</span>
<span class="sd">        the `_content` attribute : len() if __len__ exists, 0</span>
<span class="sd">        otherwise.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">_content</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">return</span> <span class="mi">0</span>
        <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="p">,</span> <span class="s1">&#39;__len__&#39;</span><span class="p">):</span>
            <span class="k">return</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="p">)</span>
        <span class="k">return</span> <span class="mi">0</span>


    <span class="k">def</span> <span class="nf">__str__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="s1">&#39;</span><span class="si">{}</span><span class="s1"> #</span><span class="si">{}</span><span class="s1">&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="vm">__name__</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">agid</span><span class="p">)</span>

    <span class="fm">__repr__</span> <span class="o">=</span> <span class="fm">__str__</span>

    <span class="k">def</span> <span class="nf">__eq__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Two agents are considered equal if they belong to the same</span>
<span class="sd">        class and have the same agent ID. (This is consistent with the</span>
<span class="sd">        fact that all instances are stored by each class using the</span>
<span class="sd">        agent ID as key.)</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span> <span class="o">==</span> <span class="n">other</span><span class="o">.</span><span class="vm">__class__</span>\
            <span class="ow">and</span> <span class="bp">self</span><span class="o">.</span><span class="n">agid</span> <span class="o">==</span> <span class="n">other</span><span class="o">.</span><span class="n">agid</span>

    <span class="k">def</span> <span class="nf">__lt__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">other</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return an order for sorting agents. In this simple method</span>
<span class="sd">        the order is defined by sorting classes, then agents IDs.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">agid</span> <span class="o">&lt;</span> <span class="n">other</span><span class="o">.</span><span class="n">agid</span> <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span> <span class="o">==</span> <span class="n">other</span><span class="o">.</span><span class="vm">__class__</span>\
            <span class="k">else</span> <span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="vm">__name__</span> <span class="o">&lt;</span> <span class="n">other</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="vm">__name__</span>

<div class="viewcode-block" id="AbstractAgent.get_model_value"><a class="viewcode-back" href="../../../../emulsion_for_modellers.html#emulsion.agent.core.abstract_agent.AbstractAgent.get_model_value">[docs]</a>    <span class="k">def</span> <span class="nf">get_model_value</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return the value corresponding to the specified name in the model</span>
<span class="sd">        of the agent. If the name refers to a function, apply this</span>
<span class="sd">        function to the agent.</span>

<span class="sd">        TAG: USER</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="n">retrieve_value</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">get_value</span><span class="p">(</span><span class="n">name</span><span class="p">),</span> <span class="bp">self</span><span class="p">)</span></div>

    <span class="nd">@property</span>
    <span class="k">def</span> <span class="nf">delta_t</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;A shortcut to `self.model.delta_t`.&quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">delta_t</span>

    <span class="nd">@property</span>
    <span class="k">def</span> <span class="nf">time</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;The time elapsed since the beginning of simulation (in time</span>
<span class="sd">        units).</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">delta_t</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">step</span>

<div class="viewcode-block" id="AbstractAgent.die"><a class="viewcode-back" href="../../../../emulsion_for_modellers.html#emulsion.agent.core.abstract_agent.AbstractAgent.die">[docs]</a>    <span class="k">def</span> <span class="nf">die</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Operation performed when the agent is removed from the</span>
<span class="sd">        simulation. Recursively destroy agents contained in the</span>
<span class="sd">        current agent if any, and remove the current agent from the</span>
<span class="sd">        agdict attribute of its class.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="p">:</span>
            <span class="k">for</span> <span class="n">agent</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="p">:</span>
                <span class="n">agent</span><span class="o">.</span><span class="n">die</span><span class="p">()</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">_agkey</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="n">agdict</span><span class="p">:</span>
            <span class="k">del</span> <span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="n">agdict</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">_agkey</span><span class="p">]</span></div>

<div class="viewcode-block" id="AbstractAgent.get_information"><a class="viewcode-back" href="../../../../emulsion_for_modellers.html#emulsion.agent.core.abstract_agent.AbstractAgent.get_information">[docs]</a>    <span class="k">def</span> <span class="nf">get_information</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return the value corresponding to the specified name in the</span>
<span class="sd">        agent. This value can be stored either as an attribute or a</span>
<span class="sd">        property-like descriptor (and thus accessed through an</span>
<span class="sd">        attribute-like syntax), or as a State Variable using a</span>
<span class="sd">        StateVarDict attribute named ``statevars``.</span>

<span class="sd">        Example:</span>
<span class="sd">        class Cow(AtomAgent):</span>
<span class="sd">            ...</span>
<span class="sd">            @property</span>
<span class="sd">            def age(self):</span>
<span class="sd">                return self._age</span>

<span class="sd">        c = Cow()</span>
<span class="sd">        c.get_information(&#39;age&#39;)</span>
<span class="sd">        # -&gt; access through property &#39;age&#39;</span>
<span class="sd">        c.get_information(&#39;health_state&#39;)</span>
<span class="sd">        # -&gt; access through statevar &#39;health_state&#39; (present in any Unit),</span>
<span class="sd">        # unless a &#39;health_state&#39; attribute or property is explicitly</span>
<span class="sd">        # redefined to override the state variable</span>


<span class="sd">        TAG: USER</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># return getattr(self, name) if hasattr(self, name)\</span>
        <span class="c1">#     else getattr(self.statevars, name)</span>
        <span class="c1"># REWRITTEN for efficiency improvement</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="k">return</span> <span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">)</span>\
                <span class="k">if</span> <span class="n">name</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_mbr_cache</span>\
                   <span class="k">else</span> <span class="nb">getattr</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="p">,</span> <span class="n">name</span><span class="p">)</span>
        <span class="c1"># do NOT use self.statevars[name] to ensure recursive lookup</span>

        <span class="k">except</span> <span class="ne">AttributeError</span><span class="p">:</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">_host</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="c1"># print(&#39;%s trying to find %s in %s&#39; %(self, name, self.get_host()))</span>
                <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_host</span><span class="p">()</span><span class="o">.</span><span class="n">get_information</span><span class="p">(</span><span class="n">name</span><span class="p">)</span>
                <span class="c1"># print(&#39;Found: %s&#39; % (result,))</span>
            <span class="k">elif</span> <span class="n">name</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">_values</span><span class="p">:</span>
                <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_model_value</span><span class="p">(</span><span class="n">name</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="c1"># print(str(self), self._mbr_cache)</span>
                <span class="k">raise</span> <span class="n">StateVarNotFoundException</span><span class="p">(</span><span class="n">name</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span></div>

<div class="viewcode-block" id="AbstractAgent.set_information"><a class="viewcode-back" href="../../../../emulsion_for_modellers.html#emulsion.agent.core.abstract_agent.AbstractAgent.set_information">[docs]</a>    <span class="k">def</span> <span class="nf">set_information</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">value</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Set the specified value for the statevar/attribute.</span>

<span class="sd">        TAG: USER</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># if hasattr(self, name):</span>
        <span class="c1">#     setattr(self, name, value)</span>
        <span class="c1"># else:</span>
        <span class="c1">#     setattr(self.statevars, name, value)</span>
        <span class="c1"># REWRITTEN for efficiency improvement</span>
        <span class="k">if</span> <span class="n">name</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_mbr_cache</span><span class="p">:</span>
            <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">value</span><span class="p">)</span>
            <span class="c1"># print(self, &#39;changed&#39;, name, &#39;to&#39;, value, &#39;through property&#39;)</span>
        <span class="k">elif</span> <span class="n">name</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="p">:</span>
            <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">value</span><span class="p">)</span>
            <span class="c1"># do NOT use self.statevars[name]=value to ensure recursive lookup</span>
            <span class="c1"># print(self, &#39;changed&#39;, name, &#39;to&#39;, value, &#39;through statevar&#39;)</span>
        <span class="k">elif</span> <span class="bp">self</span><span class="o">.</span><span class="n">_host</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">get_host</span><span class="p">()</span><span class="o">.</span><span class="n">set_information</span><span class="p">(</span><span class="n">name</span><span class="p">,</span> <span class="n">value</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="bp">self</span><span class="p">),</span> <span class="bp">self</span><span class="o">.</span><span class="n">_mbr_cache</span><span class="p">)</span>
            <span class="k">raise</span> <span class="n">StateVarNotFoundException</span><span class="p">(</span><span class="n">name</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span></div>

<div class="viewcode-block" id="AbstractAgent.init_time_entered"><a class="viewcode-back" href="../../../../emulsion_for_modellers.html#emulsion.agent.core.abstract_agent.AbstractAgent.init_time_entered">[docs]</a>    <span class="k">def</span> <span class="nf">init_time_entered</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">machine_name</span><span class="p">,</span> <span class="n">advance</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">nb_timesteps</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Initialize the time step value when this agent is entering a new</span>
<span class="sd">        state of the specified state machine. A (positive) `advance`</span>
<span class="sd">        value can be provided to mimick an earlier entering in the</span>
<span class="sd">        state. By default, a `_time_to_exit` value is set according to</span>
<span class="sd">        the value of `nb_timesteps`.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">key</span> <span class="o">=</span> <span class="s1">&#39;_time_entered_</span><span class="si">{}</span><span class="s1">&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">machine_name</span><span class="p">)</span>
        <span class="n">key_TTE</span> <span class="o">=</span> <span class="s1">&#39;_time_to_exit_</span><span class="si">{}</span><span class="s1">&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">machine_name</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">step</span> <span class="o">-</span> <span class="n">advance</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="n">key_TTE</span><span class="p">]</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="o">+</span> <span class="n">nb_timesteps</span></div>
        <span class="c1"># print(value)</span>

<div class="viewcode-block" id="AbstractAgent.change_state"><a class="viewcode-back" href="../../../../emulsion_for_modellers.html#emulsion.agent.core.abstract_agent.AbstractAgent.change_state">[docs]</a>    <span class="k">def</span> <span class="nf">change_state</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">machine_name</span><span class="p">,</span> <span class="n">new_state</span><span class="p">,</span> <span class="n">do_actions</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Change the state of this agent for the specified state machine to</span>
<span class="sd">        `new_state`. The `_time_entered_MACHINE` value for this state machine</span>
<span class="sd">        is initialized. If do_actions is True, perform the actions to</span>
<span class="sd">        do on_exit from the previous state (if any) and those to do</span>
<span class="sd">        on_enter in the new state (if any).</span>

<span class="sd">        TAG: USER?</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># retrieve the state machine from its name</span>
        <span class="n">state_machine</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">state_machines</span><span class="p">[</span><span class="n">machine_name</span><span class="p">]</span>
        <span class="c1"># if asked to do actions, first execute the &#39;on_exit&#39; actions</span>
        <span class="c1"># of current state</span>
        <span class="k">if</span> <span class="n">do_actions</span><span class="p">:</span>
            <span class="n">current_state</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="n">machine_name</span><span class="p">]</span>\
                            <span class="k">if</span> <span class="n">machine_name</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span> <span class="k">else</span> <span class="kc">None</span>
            <span class="k">if</span> <span class="n">current_state</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">do_state_actions</span><span class="p">(</span><span class="s1">&#39;on_exit&#39;</span><span class="p">,</span> <span class="n">state_machine</span><span class="p">,</span> <span class="n">current_state</span><span class="o">.</span><span class="n">name</span><span class="p">)</span>
        <span class="c1"># change the state in the statevar</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="n">machine_name</span><span class="p">]</span> <span class="o">=</span> <span class="n">new_state</span>
        <span class="c1"># initialize the _time_entered_STATEMACHINE variable</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">init_time_entered</span><span class="p">(</span><span class="n">machine_name</span><span class="p">)</span>
        <span class="c1"># if asked to do actions, execute the &#39;on_enter&#39; actions of</span>
        <span class="c1"># the new state</span>
        <span class="k">if</span> <span class="n">do_actions</span><span class="p">:</span>
            <span class="c1"># do on_enter actions associated to the new value</span>
            <span class="c1"># print(f&#39;doing on_enter for {state_machine} in {new_state}&#39;)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">do_state_actions</span><span class="p">(</span><span class="s1">&#39;on_enter&#39;</span><span class="p">,</span> <span class="n">state_machine</span><span class="p">,</span> <span class="n">new_state</span><span class="o">.</span><span class="n">name</span><span class="p">,</span> <span class="n">agents</span><span class="o">=</span><span class="p">[</span><span class="bp">self</span><span class="p">])</span></div>

    <span class="c1"># DEPRECATED in &gt;0.9.5</span>
    <span class="c1"># def init_time_to_live(self, machine_name, value):</span>
    <span class="c1">#     &quot;&quot;&quot;Initialize the time this agent is expected to stay in the</span>
    <span class="c1">#     current state of the specified state machine. If an offset is</span>
    <span class="c1">#     defined for this state machine, it is added to the specified</span>
    <span class="c1">#     value, then reset to 0.</span>

    <span class="c1">#     &quot;&quot;&quot;</span>
    <span class="c1">#     key = &#39;_time_spent_{}&#39;.format(machine_name)</span>
    <span class="c1">#     keymax = &#39;_time_to_live_{}&#39;.format(machine_name)</span>
    <span class="c1">#     keyoff = &#39;_time_offset_{}&#39;.format(machine_name)</span>
    <span class="c1">#     if keyoff not in self.statevars:</span>
    <span class="c1">#         self.statevars[keyoff] = 0</span>
    <span class="c1">#     self.statevars[key] = 0</span>
    <span class="c1">#     # compute the time to live w.r.t. the time step duration</span>
    <span class="c1">#     # (deltat_t)</span>
    <span class="c1">#     self.statevars[keymax] = int(np.round((value + self.statevars[keyoff])\</span>
    <span class="c1">#                                           / self.model.delta_t))</span>
    <span class="c1">#     self.statevars[keyoff] = 0</span>
    <span class="c1">#     # print(value)</span>

<div class="viewcode-block" id="AbstractAgent.update_time_to_exit"><a class="viewcode-back" href="../../../../emulsion_for_modellers.html#emulsion.agent.core.abstract_agent.AbstractAgent.update_time_to_exit">[docs]</a>    <span class="k">def</span> <span class="nf">update_time_to_exit</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">machine_name</span><span class="p">,</span> <span class="n">duration</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Update the *duration* this agent is expected to stay in the current</span>
<span class="sd">        state of the specified state machine (*machine_name*).</span>

<span class="sd">        The time step value after which the agent is allowed to leave</span>
<span class="sd">        the current state is stored in a statevar called</span>
<span class="sd">        ``_time_to_exit_machine_name``, is computed from the</span>
<span class="sd">        current time (``step``) plus the *duration*.</span>

<span class="sd">        Args:</span>
<span class="sd">            machine_name (str): name of the state machine for which</span>
<span class="sd">              the duration in the current state must be updated</span>
<span class="sd">            duration (datetime.timedelta): the new duration for the</span>
<span class="sd">              agent to stay in the current state, calculated from the</span>
<span class="sd">              current time in the simulation</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="p">(</span><span class="nb">type</span><span class="p">(</span><span class="n">duration</span><span class="p">)</span> <span class="o">==</span> <span class="nb">str</span><span class="p">):</span> <span class="c1"># DEBUG: should not happen !!!</span>
            <span class="nb">print</span><span class="p">(</span><span class="n">duration</span><span class="p">)</span>
        <span class="n">key</span> <span class="o">=</span> <span class="s1">&#39;_time_to_exit_</span><span class="si">{}</span><span class="s1">&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">machine_name</span><span class="p">)</span>
        <span class="c1"># compute the time to live w.r.t. the time step duration</span>
        <span class="c1"># (deltat_t)</span>
        <span class="n">nb_timesteps</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">round</span><span class="p">(</span><span class="n">duration</span> <span class="o">/</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">delta_t</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">step</span> <span class="o">+</span> <span class="n">nb_timesteps</span></div>
        <span class="c1"># print(value)</span>



    <span class="c1"># DEPRECATED in &gt;0.9.5</span>
    <span class="c1"># def increase_time_spent(self, machine_name):</span>
    <span class="c1">#     &quot;&quot;&quot;Increase the time this agent has spent in the current state of the</span>
    <span class="c1">#     specified state machine.</span>

    <span class="c1">#     &quot;&quot;&quot;</span>
    <span class="c1">#     self.statevars[&#39;_time_spent_{}&#39;.format(machine_name)] += 1</span>

    <span class="c1"># DEPRECATED in &gt;0.9.5</span>
    <span class="c1"># def set_time_to_live_offset(self, machine_name, value):</span>
    <span class="c1">#     &quot;&quot;&quot;Specify an additional value to the time this agent is</span>
    <span class="c1">#     expected to stay in the next state of the specified state</span>
    <span class="c1">#     machine.</span>

    <span class="c1">#     &quot;&quot;&quot;</span>
    <span class="c1">#     self.statevars[&#39;_time_offset_{}&#39;.format(machine_name)] = value</span>

<div class="viewcode-block" id="AbstractAgent.duration_in_current_state"><a class="viewcode-back" href="../../../../emulsion_for_modellers.html#emulsion.agent.core.abstract_agent.AbstractAgent.duration_in_current_state">[docs]</a>    <span class="k">def</span> <span class="nf">duration_in_current_state</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">machine_name</span><span class="p">:</span> <span class="nb">str</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">float</span><span class="p">:</span>
        <span class="sd">&quot;&quot;&quot;Return the duration (in time units) this agent has spent in the</span>
<span class="sd">        current state of the specified state machine (*machine_name*).</span>

<span class="sd">        Args:</span>
<span class="sd">            machine_name: the name of the state machine for which</span>
<span class="sd">              the duration in the current state must be computed</span>

<span class="sd">        Returns:</span>
<span class="sd">          A duration (expressed in time units) corresponding to the</span>
<span class="sd">          duration spent in the current state for this state machine.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">step</span> <span class="o">-</span>\
                <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="s1">&#39;_time_entered_</span><span class="si">{}</span><span class="s1">&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">machine_name</span><span class="p">)])</span> <span class="o">*</span>\
            <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">delta_t</span></div>

<div class="viewcode-block" id="AbstractAgent.reapply_prototype"><a class="viewcode-back" href="../../../../emulsion_for_modellers.html#emulsion.agent.core.abstract_agent.AbstractAgent.reapply_prototype">[docs]</a>    <span class="k">def</span> <span class="nf">reapply_prototype</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">execute_actions</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Reapply to self the last prototype that was used on this agent. The</span>
<span class="sd">        whole definition (not the name) of the prototype to apply is</span>
<span class="sd">        stored in attribute ``_last_prototype``. Use e.g. to apply a</span>
<span class="sd">        prototype first without actions, then reapply it with actions.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">apply_prototype</span><span class="p">(</span><span class="n">prototype</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_last_prototype</span><span class="p">,</span> <span class="n">execute_actions</span><span class="o">=</span><span class="n">execute_actions</span><span class="p">)</span></div>

<div class="viewcode-block" id="AbstractAgent.apply_prototype"><a class="viewcode-back" href="../../../../emulsion_for_modellers.html#emulsion.agent.core.abstract_agent.AbstractAgent.apply_prototype">[docs]</a>    <span class="k">def</span> <span class="nf">apply_prototype</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">prototype</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">execute_actions</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Apply the prototype with the specified name to this agent. A</span>
<span class="sd">        prototype is basically a dictionary of statevars associated to</span>
<span class="sd">        values. Thus this method changes specific statevars to new</span>
<span class="sd">        values as required in the prototype. Other statevars are kept</span>
<span class="sd">        unchanged. If a statevar was no amongst those of this agent,</span>
<span class="sd">        it is added. When statevars hold the state of a state machine,</span>
<span class="sd">        the state is changed with correct initialization of</span>
<span class="sd">        corresponding attributes (mainly _time_entered) ; if</span>
<span class="sd">        execute_actions is True, on_enter/on_exit actions are</span>
<span class="sd">        performed.</span>

<span class="sd">        TAG: USER</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># give priority to named prototypes if provided, else</span>
        <span class="k">if</span> <span class="n">name</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">prototype</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">get_prototype</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">level</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_information</span><span class="p">(</span><span class="s1">&#39;simu_id&#39;</span><span class="p">))</span>
        <span class="k">if</span> <span class="n">prototype</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;WARNING: agent </span><span class="si">{}</span><span class="s2"> was asked to apply inexistent prototype&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="bp">self</span><span class="p">))</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_last_prototype</span> <span class="o">=</span> <span class="n">prototype</span>
        <span class="c1"># print(self, &#39;applying prototype&#39;, name, prototype, execute_actions)</span>
        <span class="c1"># if any &#39;begin_with&#39; sequence is defined, apply immediately in the specified order</span>
        <span class="k">if</span> <span class="s1">&#39;begin_with&#39;</span> <span class="ow">in</span> <span class="n">prototype</span><span class="p">:</span>
            <span class="n">l_tuples</span> <span class="o">=</span> <span class="n">prototype</span><span class="p">[</span><span class="s1">&#39;begin_with&#39;</span><span class="p">]</span>
            <span class="k">for</span> <span class="n">var</span><span class="p">,</span> <span class="n">value</span> <span class="ow">in</span> <span class="n">l_tuples</span><span class="p">:</span>
                <span class="n">val</span> <span class="o">=</span> <span class="n">value</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="k">if</span> <span class="n">callable</span><span class="p">(</span><span class="n">value</span><span class="p">)</span> <span class="k">else</span> <span class="n">value</span>
                <span class="c1"># set the value to the variable depending on the nature of the variable</span>
                <span class="k">if</span> <span class="n">var</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">state_machines</span><span class="p">:</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">change_state</span><span class="p">(</span><span class="n">var</span><span class="p">,</span> <span class="n">val</span><span class="p">,</span> <span class="n">do_actions</span><span class="o">=</span><span class="n">execute_actions</span><span class="p">)</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="n">var</span><span class="p">]</span> <span class="o">=</span> <span class="n">val</span>
        <span class="c1"># for regular cases:</span>
        <span class="c1"># apply changes in states first, then other variables</span>
        <span class="k">for</span> <span class="n">var</span><span class="p">,</span> <span class="n">value</span> <span class="ow">in</span> <span class="n">prototype</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="k">if</span> <span class="n">var</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">state_machines</span><span class="p">:</span>
                <span class="n">val</span> <span class="o">=</span> <span class="n">value</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="k">if</span> <span class="n">callable</span><span class="p">(</span><span class="n">value</span><span class="p">)</span> <span class="k">else</span> <span class="n">value</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">change_state</span><span class="p">(</span><span class="n">var</span><span class="p">,</span> <span class="n">val</span><span class="p">,</span> <span class="n">do_actions</span><span class="o">=</span><span class="n">execute_actions</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">var</span><span class="p">,</span> <span class="n">value</span> <span class="ow">in</span> <span class="n">prototype</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="k">if</span> <span class="n">var</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">state_machines</span> <span class="ow">and</span> <span class="n">var</span> <span class="o">!=</span> <span class="s1">&#39;in_order&#39;</span><span class="p">:</span>
                <span class="n">val</span> <span class="o">=</span> <span class="n">value</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="k">if</span> <span class="n">callable</span><span class="p">(</span><span class="n">value</span><span class="p">)</span> <span class="k">else</span> <span class="n">value</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="n">var</span><span class="p">]</span> <span class="o">=</span> <span class="n">val</span>
        <span class="c1"># if any &#39;end_with&#39; sequence is defined, apply finally in the specified order</span>
        <span class="k">if</span> <span class="s1">&#39;end_with&#39;</span> <span class="ow">in</span> <span class="n">prototype</span><span class="p">:</span>
            <span class="n">l_tuples</span> <span class="o">=</span> <span class="n">prototype</span><span class="p">[</span><span class="s1">&#39;end_with&#39;</span><span class="p">]</span>
            <span class="k">for</span> <span class="n">var</span><span class="p">,</span> <span class="n">value</span> <span class="ow">in</span> <span class="n">l_tuples</span><span class="p">:</span>
                <span class="n">val</span> <span class="o">=</span> <span class="n">value</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="k">if</span> <span class="n">callable</span><span class="p">(</span><span class="n">value</span><span class="p">)</span> <span class="k">else</span> <span class="n">value</span>
                <span class="c1"># set the value to the variable depending on the nature of the variable</span>
                <span class="k">if</span> <span class="n">var</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">state_machines</span><span class="p">:</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">change_state</span><span class="p">(</span><span class="n">var</span><span class="p">,</span> <span class="n">val</span><span class="p">,</span> <span class="n">do_actions</span><span class="o">=</span><span class="n">execute_actions</span><span class="p">)</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="n">var</span><span class="p">]</span> <span class="o">=</span> <span class="n">val</span>

        <span class="c1">### ADDED TO ENSURE CONSISTENCY WHEN APPLYING PROTOTYPES.</span>
        <span class="c1">### TODO: revise prototype application to enhance efficiency</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">_host</span> <span class="ow">and</span> <span class="s1">&#39;MASTER&#39;</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_host</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">_host</span><span class="p">[</span><span class="s1">&#39;MASTER&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">get_host</span><span class="p">()</span><span class="o">.</span><span class="n">make_all_consistent</span><span class="p">()</span></div>

<div class="viewcode-block" id="AbstractAgent.apply_initial_prototype"><a class="viewcode-back" href="../../../../emulsion_for_modellers.html#emulsion.agent.core.abstract_agent.AbstractAgent.apply_initial_prototype">[docs]</a>    <span class="k">def</span> <span class="nf">apply_initial_prototype</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">prototype</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">execute_actions</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Apply prototype to a newly created agent. This function is called</span>
<span class="sd">        by `new_atom` in `MultiProcessManager` and redefined to do nothing in</span>
<span class="sd">        this class, in order to ensure that the prototype of a level is</span>
<span class="sd">        applied before creating entities for the sublevels.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># print(self, &#39;applying initial prototype&#39;, name, prototype, execute_actions)</span>
        <span class="k">if</span> <span class="n">name</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="c1"># print(&#39;applying prototype&#39;, name, &#39;on&#39;, self)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">apply_prototype</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="n">name</span><span class="p">,</span> <span class="n">execute_actions</span><span class="o">=</span><span class="n">execute_actions</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">prototype</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="c1"># print(&#39;applying custom prototype&#39;, prototype, &#39;on&#39;, self)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">apply_prototype</span><span class="p">(</span><span class="n">prototype</span><span class="o">=</span><span class="n">prototype</span><span class="p">,</span>
                                 <span class="n">execute_actions</span><span class="o">=</span><span class="n">execute_actions</span><span class="p">)</span></div></div>


<span class="c1"># Methods useful to model designers</span>
<span class="n">AbstractAgent</span><span class="o">.</span><span class="n">duration_in_current_state</span><span class="o">.</span><span class="n">__USER_METHOD__</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;Durations&#39;</span><span class="p">]</span>
<span class="n">AbstractAgent</span><span class="o">.</span><span class="n">update_time_to_exit</span><span class="o">.</span><span class="n">__USER_METHOD__</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;Durations&#39;</span><span class="p">]</span>
<span class="n">AbstractAgent</span><span class="o">.</span><span class="n">apply_prototype</span><span class="o">.</span><span class="n">__USER_METHOD__</span> <span class="o">=</span>\
  <span class="p">[</span><span class="s1">&#39;Agent State and Variable Changes&#39;</span><span class="p">]</span>
</pre></div>

          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../../../index.html">EMULSION</a></h1>



<p class="blurb">Epidemiological Multi-Level Simulation Framework</p>






<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Information.html">1. Information</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Install.html">2. Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Getting_started.html">3. Getting started with EMULSION</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Modelling_principles.html">4. Modelling principles</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Modelling_language_basics.html">5. Modelling language (basics)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Modelling_language_advanced.html">6. Modelling language (advanced)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Feature_examples.html">7. Feature examples</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Release_notes.html">8. Release notes</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/License.html">9. License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../emulsion_for_modellers.html">10. High-level functions for model designers</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../emulsion.html">11. emulsion package</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../../../index.html">Documentation overview</a><ul>
  <li><a href="../../../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2016, INRAE and Univ. Lille.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 1.8.5</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.10</a>
      
    </div>

    

    
  </body>
</html>